function conversion()
	local alreadydone = {}
	
	for i,v in pairs(features) do
		local words = v[1]
		
		local operator = words[2]
		
		if (operator == "is") then
			local output = {}
			local name = words[1]
			local thing = words[3]
			
			if (getmat(thing) ~= nil) or (thing == "not " .. name) then
				if (featureindex[name] ~= nil) and (alreadydone[name] == nil) then
					alreadydone[name] = 1
					
					for a,b in ipairs(featureindex[name]) do
						local rule = b[1]
						local conds = b[2]
						local target,verb,object = rule[1],rule[2],rule[3]
						
						if (target == name) and (verb == "is") and (object ~= name) and (object ~= "word") then
							if (object ~= "text") then
								if (object == "not " .. name) then
									table.insert(output, {"error", conds})
								else
									for d,mat in pairs(objectlist) do
										if (d ~= "group") and (d == object) then
											table.insert(output, {object, conds})
										end
									end
								end
							else
								if (name ~= object) then
									table.insert(output, {object, conds})
								end
							end
						end
					end
				end
				
				if (#output > 0) then
					local conversions = {}
					
					for k,v3 in pairs(output) do
						local object = v3[1]
						local conds = v3[2]
						
						if (object ~= "all") and (object ~= "text") and (object ~= "group") and (object ~= "word") then
							table.insert(conversions, v3)
						elseif (object == "all") then
							addaction(0,{"createall",{name,conds}})
							--createall({name,conds})
						elseif (object == "text") then
							table.insert(conversions, {"text_" .. name,conds})
						end
					end
					
					if (#conversions > 0) then
						if (name ~= "text") then
							convert(name,conversions)
						else
							local convertthese = {}
							for a,b in pairs(units) do
								if (b.strings[UNITTYPE] == "text") then
									table.insert(convertthese, b.strings[UNITNAME])
								end
							end
							
							if (#convertthese > 0) then
								for a,b in pairs(convertthese) do
									convert(b,conversions)
								end
							end
						end
					end
				end
			end
		end
	end
end

function convert(stuff,mats)
	local layer = map[0]
	local delthese = {}
	local mat1 = stuff
	
	if (mat1 ~= "empty") and (mat1 ~= "level") then
		if (unitlists[mat1] ~= nil) then
			for i,unitid in pairs(unitlists[mat1]) do
				local unit = mmf.newObject(unitid)
				local x,y,dir,id = unit.values[XPOS],unit.values[YPOS],unit.values[DIR],unit.values[ID]
				local name = getname(unit)
				
				if (name ~= "text") or ((name == "text") and (mat1 == unit.strings[UNITNAME])) then
					if (unit.flags[CONVERTED] == false) then
						for a,matdata in pairs(mats) do
							local mat2 = matdata[1]
							local conds = matdata[2]
							
							if testcond(conds,unit.fixed) then
								local ingameid = 0
								if (a == 1) then
									ingameid = id
								elseif (a > 1) then
									ingameid = newid()
								end
								print(mat2)
								addaction(unit.fixed,{"convert",mat2,ingameid})
								unit.flags[CONVERTED] = true
							end
						end
					end
				end
			end
		end
	elseif (mat1 == "empty") then
		for a,matdata in pairs(mats) do
			local mat2 = matdata[1]
			local conds = matdata[2]

			if (mat2 ~= "empty") then
				local convunitmap = {}
				
				for a,unit in pairs(units) do
					local tileid = unit.values[XPOS] + unit.values[YPOS] * roomsize
					convunitmap[tileid] = 1
				end
				
				for i=0,roomsize-1 do
					for j=0,roomsize-1 do
						local empty = 1
						
						local tileid = i + j * roomsize
						if (convunitmap[tileid] ~= nil) then
							empty = 0
						end
						
						if (layer:get_x(i,j) ~= 255) then
							empty = 0
						end

						if (empty == 1) and testcond(conds,2,i,j) then
							addaction(2,{"emptyconvert",mat2,i,j})
						end
					end
				end
			end
		end
	end
	
	--[[
	if (#delthese > 0) then
		for i,unitid in ipairs(delthese) do
			local unit = mmf.newObject(unitid)
			addundo({"remove",unit.strings[UNITNAME],unit.values[XPOS],unit.values[YPOS],unit.values[DIR],unit.values[ID]})
			delunit(unitid)
			MF_specialremove(unitid,0,2)
		end
	end
	]]--
end

function doconvert(data)
	local style = data[2]
	local mat2 = data[3]
	
	local unitid = data[1]
	local unit = {}
	local x,y,dir,name,id,completed = 0,0,0,"",0,0
	
	if (unitid ~= 2) then
		unit = mmf.newObject(unitid)
		x,y,dir,name,id,completed = unit.values[XPOS],unit.values[YPOS],unit.values[DIR],unit.strings[UNITNAME],unit.values[ID],unit.values[COMPLETED]
	end
	
	if (style == "convert") then
		local ingameid = data[4]
		local delthis = false
			
		if (mat2 ~= "empty") and (mat2 ~= "error") then
			--MF_alert(tostring(id) .. " unit, " .. tostring(data[1]) .. ", name: " .. name .. ", result: " .. tostring(ingameid))
			print(mat2)
			
			local unitname = unitreference[mat2]
			
			local newunitid = MF_emptycreate(unitname,x,y)
			local newunit = mmf.newObject(newunitid)
			
			newunit.values[ONLINE] = 1
			newunit.values[XPOS] = x
			newunit.values[YPOS] = y
			newunit.values[DIR] = dir
			
			newunit.values[COMPLETED] = completed
			
			newunit.values[ID] = ingameid
			
			newunit.values[EFFECT] = 1
			newunit.flags[9] = true
			newunit.flags[CONVERTED] = true
			
			addunit(newunitid)
			addunitmap(newunitid,x,y)
			dynamic(newunitid)

			addundo({"create",newunit.strings[UNITNAME],ingameid})

			if (newunit.strings[UNITTYPE] == "text") then
				updatecode = 1
			end
			
			delthis = true
		elseif (mat2 == "error") then
			if (unitid ~= 2) then
				paradox[id] = 1
			end
			
			delthis = true
		else
			if testcond(conds,unit.fixed) then
				updateunitmap(unitid,x,y,x,y)
				delthis = true
			end
		end
		
		if delthis and (unit.flags[15] == false) then
			addundo({"remove",unit.strings[UNITNAME],unit.values[XPOS],unit.values[YPOS],unit.values[DIR],unit.values[ID]})
			delunit(unitid)
			dynamic(unitid)
			MF_specialremove(unitid,0,2)
		end
	elseif (style == "emptyconvert") then
		local i = data[4]
		local j = data[5]
		local unitname = unitreference[mat2]
		local newunitid = MF_emptycreate(unitname,i,j)
		local newunit = mmf.newObject(newunitid)
		
		local id = newid()
		local dir = math.random(0,3)
		
		newunit.values[ONLINE] = 1
		newunit.values[XPOS] = i
		newunit.values[YPOS] = j
		newunit.values[DIR] = dir
		newunit.values[ID] = id
		newunit.values[EFFECT] = 1
		newunit.flags[9] = true
		newunit.flags[CONVERTED] = true
		
		addunit(newunitid)
		addunitmap(newunitid,i,j)
		dynamic(newunitid)
		
		addundo({"create",newunit.strings[UNITNAME],id})
		
		if (newunit.strings[UNITTYPE] == "text") then
			updatecode = 1
		end
	end
end

function convertlevel()
end