function setupmenu(editorid,editor2id)
	editor = mmf.newObject(editorid)
	editor2 = mmf.newObject(editor2id)
	menu = {"intro"}
	changes = {}
end

function generatetiles()
	tilereference = {}
	tilereference["0,0"] = ""
	
	for i,tile in pairs(tileslist) do
		local tiledata = tile.tile
		
		local x = tiledata[1]
		local y = tiledata[2]
		
		local id = tostring(x) .. "," .. tostring(y)
		
		tilereference[id] = i
	end
end

function worldinit()
	unitreference = {}
	
	for i,tile in pairs(tileslist) do
		local thisid = MF_create(i)
		local name = tile.name or "error"
		local sprite = tile.sprite or name
		local root = tile.sprite_in_root or false
		MF_changesprite(thisid,sprite,root)
		MF_cleanremove(thisid)
		
		if (name ~= "error") then
			unitreference[name] = i
		end
	end
end

function loadtile(x,y)
	local id = tostring(x) .. "," .. tostring(y)
	
	if (tilereference[id] ~= nil) then
		return tilereference[id]
	else
		print("Couldn't find object with tile id: " .. tostring(x) .. ", " .. tostring(y))
		return "error"
	end
end

function firstlevel()
	local world = generaldata.strings[WORLD]
	local level = generaldata.strings[CURRLEVEL]
	
	if (string.len(level) == 0) then
		generaldata.strings[CURRLEVEL] = MF_read("save","savespots",world)
		
		local flevel = MF_read("world","general","firstlevel")
		local slevel = MF_read("world","general","start")
		
		local fstatus = tonumber(MF_read("save",world,flevel)) or 0
		
		if (string.len(flevel) > 0) then
			if (fstatus < 3) then
				sublevel(slevel)
				
				generaldata.strings[CURRLEVEL] = flevel
				generaldata.strings[PARENT] = slevel
			elseif (fstatus == 3) then
				generaldata.strings[CURRLEVEL] = slevel
			end
		end
	end
	
	level = generaldata.strings[CURRLEVEL]
	
	if (string.len(level) > 0) then
		MF_setfile("level","Data/Worlds/" .. world .. "/" .. level .. ".l")
		MF_loadtilemap("Data/Worlds/" .. world .. "/" .. level .. ".l")
		
		sublevel(level)
	end
end