function code()
	if (updatecode == 1) then
		MF_removeblockeffect(0)
		
		local checkthese = {}
		local wordunitid = ""
		wordunits,wordunitid = findwordunits()
		
		if (#wordunits > 0) then
			for i,v in ipairs(wordunits) do
				table.insert(checkthese, v)
			end
		end
		
		features = {}
		featureindex = {}
		visualfeatures = {}
		local firstwords = {}
		local alreadyused = {}
		
		featureindex["text"] = {}
		featureindex["push"] = {}
		featureindex["is"] = {}
		local textpush = {"text","is","push"}
		local fulltextpush = {textpush,{},{}}
		table.insert(features, fulltextpush)
		table.insert(featureindex["text"], fulltextpush)
		table.insert(featureindex["push"], fulltextpush)
		table.insert(featureindex["is"], fulltextpush)
		
		if (#codeunits > 0) then
			for i,v in ipairs(codeunits) do
				table.insert(checkthese, v)
			end
		end
	
		if (#checkthese > 0) then
			for iid,unitid in ipairs(checkthese) do
				local unit = mmf.newObject(unitid)
				local x,y = unit.values[XPOS],unit.values[YPOS]
				local ox,oy,nox,noy = 0,0
				local tileid = x + y * roomsize

				setcolour(unit.fixed)
				
				if (alreadyused[tileid] == nil) then
					for i=1,2 do
						local drs = dirs[i+2]
						local ndrs = dirs[i]
						ox = drs[1]
						oy = drs[2]
						nox = ndrs[1]
						noy = ndrs[2]
						
						local hm = codecheck(unitid,ox,oy)
						local hm2 = codecheck(unitid,nox,noy)
						
						if (#hm == 0) and (#hm2 > 0) then
							table.insert(firstwords, {unitid, i})
							
							alreadyused[tileid] = 1
						end
					end
				end
			end
			
			docode(firstwords,wordunits)
			grouprules()
			postrules()
			updatecode = 0
			
			local newwordunits,newwordunitid = findwordunits()
			
			if (newwordunitid ~= wordunitid) then
				updatecode = 1
				code()
			else
				domaprotation()
			end
		end
	end
end

function docode(firstwords)
	if (#firstwords > 0) then
		for k,unitdata in ipairs(firstwords) do
			local unit = mmf.newObject(unitdata[1])
			local x,y = unit.values[XPOS],unit.values[YPOS]
			local ox,oy = 0,0
			local name = unit.strings[NAME]
			
			local dir = unitdata[2]
			local drs = dirs[dir]
			ox = drs[1]
			oy = drs[2]
			
			local variations = 1
			local done = false
			local sentences = {}
			local variantcount = {}
			local combo = {}
			
			local finals = {}
			
			local steps = 0
			
			while (done == false) do
				local words = codecheck(unitdata[1],ox*steps,oy*steps,wordunits)
				steps = steps + 1
				
				sentences[steps] = {}
				local sent = sentences[steps]
				
				table.insert(variantcount, #words)
				table.insert(combo, 1)
				
				if (#words > 0) then
					variations = variations * #words
					
					if (variations > #finals) then
						local limitdiff = variations - #finals
						for i=1,limitdiff do
							table.insert(finals, {})
						end
					end
					
					for i,v in ipairs(words) do
						local tile = mmf.newObject(v)
						local tilename = tile.strings[NAME]
						local tiletype = tile.values[TYPE]
						
						if (tile.strings[UNITTYPE] ~= "text") then
							tiletype = 0
						end
						
						table.insert(sent, {tilename, tiletype, v})
					end
				else
					done = true
				end
			end
			
			if (#sentences > 2) then
				for i=1,variations do
					local limit = 0
					local current = finals[i]
					local prevnot = false
					local prevletter = 0
					local letterword = ""
					done = false
					local realwordid = 1
					local letterwordids = {}
					
					for wordid=1,#variantcount do
						if (done == false) then
							if (variantcount[realwordid] > 0) then
								local sent = sentences[realwordid]
								local choice = combo[realwordid]
								local s = sent[choice]
								
								local tiletype = s[2]
								
								if (tiletype ~= 5) and (prevletter == 1) then
									local lword,ltype = findword(letterword)
									letterword = ""
									prevletter = 2
									
									if (ltype == -1) then
										limit = -1
									end
									
									tiletype = ltype
									
									s = {lword, ltype, s[3]}
								end
								
								if (tiletype ~= -1) then
									if (tiletype == 5) then
										local letter = s[1]
										
										letterword = letterword .. letter
										table.insert(letterwordids, s[3])
										prevletter = 1
									elseif (tiletype ~= 3) and (tiletype ~= 4) then
										if (tiletype == 1) then
											limit = limit - 1
										else
											limit = limit + 1
										end
									elseif (tiletype == 3) then
										if (realwordid > 1) and (prevnot == false) then
											limit = -1
										end
									end
								end
								
								if (tiletype ~= 5) then
									if (limit >= 0) and (limit <= 1) then
										table.insert(current, {s[1], s[2], s[3]})
									else
										if (realwordid > 1) and (s[3] ~= 0) then
											table.insert(firstwords, {s[3], unitdata[2]})
										end
										
										if (tiletype == 1) and (realwordid == 1) then
											limit = 0
										else
											done = true
										end
									end
								end
								
								if (tiletype == 4) then
									prevnot = true
								else
									prevnot = false
								end
								
								if (prevletter == 2) then
									realwordid = realwordid - 1
									prevletter = 0
								end
								
								realwordid = realwordid + 1
							else
								if (#current > 0) then
									local latest = current[#current]
									
									if (latest[2] == 1) or (latest[2] == 3) or (latest[2] == 4) or (latest[2] == 5) then
										table.remove(current, #current)
									end
								end
								
								done = true
							end
						end
					end
					
					combo = updatecombo(combo,variantcount)
				end
			end
			
			if (#finals > 0) then
				for i,sentence in ipairs(finals) do
					local phase = 0
					local absphase = 0
					limit = 0
					local groups = {}
					local ops = {}
					local groupid = 1
					groups[groupid] = {}
					local extra = ""
					local extraids = {}
					local prevnot = false
					local currobjtype = -1
					local mixingallowed = false
					
					local testing = ""
					
					for index,wdata in ipairs(sentence) do
						local wname = wdata[1]
						local wtype = wdata[2]
						local wid = wdata[3]
						
						testing = testing .. wname .. ", "
						
						if (wtype ~= 1) and (wtype ~= 3) and (wtype ~= 4) then
							local thisgroup = groups[groupid]
							table.insert(thisgroup, {extra .. wdata[1], wdata[2], wdata[3]})
							limit = limit + 1
							
							if (currobjtype == -1) then
								currobjtype = wtype
							else
								if (mixingallowed == false) and (currobjtype ~= wtype) then
									limit = -1
									table.insert(firstwords, {wid, dir})
								end
							end
						end
						
						if (wtype == 1) then
							if (wname ~= "and") then
								table.insert(ops, {extra .. wdata[1], wdata[2], wdata[3]})
								
								groupid = groupid + 1
								groups[groupid] = {}
								
								currobjtype = -1
								if (wname == "is") or (wname == "facing") then
									mixingallowed = true
								else
									mixingallowed = false
								end
							else
								table.insert(extraids, {extra .. wdata[1], wdata[2], wdata[3]})
							end
							limit = limit - 1
						elseif (wtype == 3) then
							if (index == 1) or prevnot then
								table.insert(ops, {extra .. wdata[1], wdata[2], wdata[3]})
								
								groupid = groupid + 1
								groups[groupid] = {}
							else
								limit = -1
							end
						end
						
						if (wtype == 4) then
							if (extra == "not ") then
								extra = ""
							else
								extra = "not "
							end
							
							table.insert(extraids, {wdata[1], wdata[2], wdata[3]})
						else
							extra = ""
						end
						
						local operators = {"is","has","on","make","follow","eat","near","alone","facing"}
						
						for c,d in ipairs(operators) do
							if (wname == d) and (phase ~= c) then
								phase = c
								absphase = absphase + 1
							end
						end
						
						if (absphase > 3) then
							local previous = sentence[a-1]
							
							if (previous[3] ~= 0) then
								table.insert(firstwords, {previous[3], dir})
							end
							
							table.remove(ops, #ops)
							table.insert(ops, {"end", 3, 0})
							break
						end
						
						if (limit < 0) or (limit > 1) then
							phase = 99
							limit = 99
							
							if (limit < 0) then
								table.remove(ops, #ops)
							elseif (limit > 1) then
								local thisgroup = groups[groupid]
								table.remove(thisgroup, #thisgroup)
								
								if (#thisgroup == 0) then
									table.remove(groups, groupid)
								end
							end
							
							table.insert(ops, {"end", 3, 0})
							break
						end
						
						if (wtype == 4) then
							prevnot = true
						else
							prevnot = false
						end
					end
					
					--MF_alert("Testing: " .. testing)
					
					if (#groups > 0) then
						for a,group in ipairs(groups) do
							local style = {}
							local prevstyle = {}
							local nextstyle = {}
							
							local nextgroup = groups[a+1]
							local nextgroup2 = groups[a+2]
							local prevgroup = groups[a-1]
							
							local word,prevword,nextword = "","",""
							
							if (ops[a] ~= nil) then
								style = ops[a]
								word = style[1]
							else
								--TEE TÄLLE JOTAIN
								--print("no operator for group " .. tostring(a) .. "/" .. tostring(#groups))
							end
							
							if (ops[a-1] ~= nil) then
								prevstyle = ops[a-1]
								prevword = prevstyle[1]
							end
							
							if (ops[a+1] ~= nil) then
								nextstyle = ops[a+1]
								nextword = nextstyle[1]
							end
							
							if (word ~= "") then
								local group1 = nil
								local group2 = nil
								local thisstyle = nil
								local condgroup = {}
								local condword = {}
								
								local isitcond,arguments = iscond(word)
								local argtype,argextra = "",{}
								
								if isitcond then
									if (arguments == true) then
										if (nextgroup ~= nil) and (nextgroup2 ~= nil) and (#nextstyle > 0) then
											--print("Arguments 1")
											group1 = group
											group2 = nextgroup2
											thisstyle = nextstyle
											table.insert(condgroup, nextgroup)
											table.insert(condword, word)
										end
										
										if (nextgroup ~= nil) and (prevgroup ~= nil) and (#prevstyle > 0) then
											--print("Arguments 2")
											group1 = prevgroup
											group2 = group
											thisstyle = prevstyle
											table.insert(condgroup, nextgroup)
											table.insert(condword, word)
										end
									elseif (arguments == false) then
										group1 = nextgroup
										group2 = nextgroup2
										thisstyle = nextstyle
										table.insert(condgroup, {})
										table.insert(condword, word)
									end
								elseif (iscond(word) == false) and (iscond(prevword) == false) and (iscond(nextword) == false) then
									group1 = group
									group2 = nextgroup
									thisstyle = style
								end
								
								local delcond = {}
								
								if (#condgroup > 0) and (arguments == true) then
									local condgrouplimit = #condgroup
									for c,d in ipairs(condgroup) do
										local thiscond = condword[c]
										local needconds = false
										
										--[[
										Eikö tämä ole ihan turha??
										for m,n in ipairs(conditions) do
											if iscond(n) then
												needconds = true
											end
										end
										]]--
										needconds = true
										
										if needconds then
											if (c <= condgrouplimit) then
												local needanti = false
												local anticonds = {}
												local condcopy = {}
												
												if (#d > 0) then
													for m,n in ipairs(d) do
														table.insert(condcopy, n[1])
													end
													
													local currid = 1
													
													for e,f in ipairs(condcopy) do
														local currcond = d[currid]
														
														local notcond = string.sub(currcond[1], 1, 3)
														
														if (notcond == "not") then
															needanti = true
															local newfname = string.sub(currcond[1], 5)
															local newf = {newfname, currcond[2], currcond[3]}
															table.insert(anticonds, newf)
															table.remove(d, currid)
															currid = currid - 1
														end
														
														currid = currid + 1
													end
												end
												
												if needanti then
													local thiscondname = condword[c]
													local condnot = string.sub(thiscondname, 1, 3)
													local newcondname = ""
													
													if (condnot ~= "not") then
														newcondname = "not " .. thiscondname
													else
														newcondname = string.sub(thiscondname, 5)
													end
													
													table.insert(condword, newcondname)
													table.insert(condgroup, anticonds)
												end
											end
											
											if (#d == 0) then
												table.insert(delcond, c)
											end
										end
									end
								end
								
								if (#delcond > 0) then
									local offset = 0
									for m,n in ipairs(delcond) do
										table.remove(condgroup, n - offset)
										table.remove(condword, n - offset)
										offset = offset + 1
									end
								end
								
								table.insert(extraids, style)
								
								if (group1 ~= nil) and (thisstyle ~= nil) then
									for c,target in ipairs(group1) do
										if (group2 ~= nil) then
											for e,object in ipairs(group2) do
												local rule = {target[1],thisstyle[1],object[1]}
												local ids = {target[3],thisstyle[3],object[3]}
												local conds = {}
												
												if (#extraids > 0) then
													for g,h in ipairs(extraids) do
														table.insert(ids,h[3])
													end
												end
												
												if (#condword > 0) then
													for m,n in ipairs(condword) do
														local thiscondname = n
														local thiscondgroup = condgroup[m]
														local condnames = {}
														
														if (#thiscondgroup > 0) then
															for o,p in ipairs(thiscondgroup) do
																table.insert(condnames, p[1])
																table.insert(ids, p[3])
															end
														end
														
														table.insert(conds, {thiscondname, condnames})
													end
												end
												
												addoption(rule,conds,ids)
											end
										end
									end
								end
							end
						end
					end
				end
			end
		end
	end
end

function codecheck(unitid,ox,oy)
	local unit = mmf.newObject(unitid)
	local x,y = unit.values[XPOS]+ox,unit.values[YPOS]+oy
	local result = {}
	
	local tileid = x + y * roomsize
	
	if (unitmap[tileid] ~= nil) then
		for i,b in ipairs(unitmap[tileid]) do
			local v = mmf.newObject(b)
			
			if (v.strings[UNITTYPE] == "text") then
				table.insert(result, b)
			else
				if (#wordunits > 0) then
					for c,d in ipairs(wordunits) do
						if (b == d) then
							table.insert(result, b)
						end
					end
				end
			end
		end
	end
	
	return result
end

function addoption(option,conds_,ids,visible)
	local visual = true
	
	if (visible ~= nil) then
		visual = visible
	end
	
	local conds = {}
	
	if (conds_ ~= nil) then
		conds = conds_
	else
		print("nil conditions in rule: " .. option[1] .. ", " .. option[2] .. ", " .. option[3])
	end
	
	if (#option == 3) then
		local rule = {option,conds,ids}
		table.insert(features, rule)
		local target = option[1]
		local effect = option[3]
		local verb = option[2]
	
		if (featureindex[effect] == nil) then
			featureindex[effect] = {}
		end
		
		if (featureindex[target] == nil) then
			featureindex[target] = {}
		end
		
		if (featureindex[verb] == nil) then
			featureindex[verb] = {}
		end
		
		table.insert(featureindex[effect], rule)
		
		table.insert(featureindex[verb], rule)
		
		if (target ~= effect) then
			table.insert(featureindex[target], rule)
		end
		
		if visual then
			local visualrule = copyrule(rule)
			table.insert(visualfeatures, visualrule)
		end
		
		if (#conds > 0) then
			for i,cond in ipairs(conds) do
				if (cond[2] ~= nil) then
					if (#cond[2] > 0) then
						local alreadyused = {}
						local delnames = {}
						local allfound = false
						
						alreadyused[target] = 1
						
						for a,b in ipairs(cond[2]) do
							if (b ~= "all") then
								alreadyused[b] = 1
							else
								allfound = true
								table.insert(delnames, a)
							end
						end
						
						if allfound then
							for a,mat in pairs(objectlist) do
								if (alreadyused[a] == nil) then
									table.insert(cond[2], a)
									alreadyused[a] = 1
								end
							end
						end
						
						if (#delnames > 0) then
							local deloffset = 0
							for a,b in ipairs(delnames) do
								table.remove(cond[2], b-deloffset)
								deloffset = deloffset + 1 
							end
						end
					end
				end
			end
		end

		local targetnot = string.sub(target, 1, 3)
		local targetnot_ = string.sub(target, 5)
		
		if (targetnot == "not") and (objectlist[targetnot_] ~= nil) then
			for i,mat in pairs(objectlist) do
				if (i ~= "empty") and (i ~= "all") and (i ~= "level") and (i ~= "group") and (i ~= targetnot_) and (i ~= "text") then
					local rule = {i,verb,effect}
					--print(i .. " " .. verb .. " " .. effect)
					local ids = {}
					local newconds = {}
					for a,b in ipairs(conds) do
						table.insert(newconds, b)
					end
					addoption(rule,newconds,ids,false)
				end
			end
		end
		
		if (effect == "all") then
			if (verb ~= "is") then 
				for i,mat in pairs(objectlist) do
					if (i ~= "empty") and (i ~= "all") and (i ~= "level") and (i ~= "group") then
						local rule = {target,verb,i}
						local ids = {}
						local newconds = {}
						for a,b in ipairs(conds) do
							table.insert(newconds, b)
						end
						addoption(rule,newconds,ids,false)
					end
				end
			end
		end

		if (target == "all") then
			for i,mat in pairs(objectlist) do
				if (i ~= "empty") and (i ~= "all") and (i ~= "level") and (i ~= "group") then
					local rule = {i,verb,effect}
					local ids = {}
					local newconds = {}
					for a,b in ipairs(conds) do
						table.insert(newconds, b)
					end
					addoption(rule,newconds,ids,false)
				end
			end
		end
	end
end

function postrules()
	local notfeatures = {}
	local limit = #features
	local newruleids = {}
	local playrulesound = false
	
	local protects = {}
	
	for i,rules in ipairs(features) do
		if (i <= limit) then
			local rule = rules[1]
			local conds = rules[2]
			local ids = rules[3]
			
			if (rule[1] == rule[3]) and (rule[2] == "is") then
				table.insert(protects, i)
			end
			
			if (ids ~= nil) then
				local works = true
				local idlist = {}
				local effectsok = false
				
				if (#ids > 0) then
					for a,b in ipairs(ids) do
						table.insert(idlist, b)
						local bunit = mmf.newObject(b)
						local btype = bunit.values[TYPE]
						
						if (btype == 1) and (bunit.strings[UNITNAME] == "text_is") then
							effectsok = true
						elseif (btype == 1) and (bunit.strings[UNITNAME] ~= "text_is") and (bunit.strings[UNITNAME] ~= "text_and") then
							effectsok = false
						end
						
						if (btype == 2) and (effectsok == false) then
							works = false
							
							if prevand then
								if (a > 1) then
									table.remove(idlist, #idlist - 1)
								end
							end
						end
					end
				end
				
				if (#idlist > 0) and works then
					for a,b in ipairs(idlist) do
						if (b ~= 0) then
							local bunit = mmf.newObject(b)
							
							if (bunit.strings[UNITTYPE] == "text") then
								setcolour(b,"active")
							end
							newruleids[b] = 1
							
							if (ruleids[b] == nil) and (#undobuffer > 1) then
								local x,y = bunit.values[XPOS],bunit.values[YPOS]
								local c1,c2 = getcolour(b,"active")
								MF_particles("bling",x,y,5,c1,c2)
								playrulesound = true
							end
						end
					end
				elseif (#idlist > 0) and (works == false) then
					for a,visualrules in pairs(visualfeatures) do
						local vrule = visualrules[1]
						local same = comparerules(rule,vrule)
						
						if same then
							table.remove(visualfeatures, a)
						end
					end
				end
			end

			local rulenot = 0
			local neweffect = ""
			
			local nothere = string.sub(rule[3], 1, 3)
			
			if (nothere == "not") then
				rulenot = 1
				neweffect = string.sub(rule[3], 5)
			end
			
			if (rulenot == 1) then
				local newconds = {}
				
				if (#conds > 0) then
					for a,cond in ipairs(conds) do
						local newcond = {cond[1],cond[2]}
						local condname = cond[1]
						local params = cond[2]
						
						local prefix = string.sub(condname, 1, 3)
						
						if (prefix == "not") then
							condname = string.sub(condname, 5)
						else
							condname = "not " .. condname
						end
						
						newcond[1] = condname
						newcond[2] = {}
						
						if (#params > 0) then
							for m,n in ipairs(params) do
								table.insert(newcond[2], n)
							end
						end
						
						table.insert(newconds, newcond)
					end
				else
					table.insert(newconds, {"never"})
				end
				
				local newbaserule = {rule[1],rule[2],neweffect}
				
				local target = rule[1]
				local verb = rule[2]
				
				for a,b in ipairs(featureindex[target]) do
					local same = comparerules(newbaserule,b[1])
					
					if same then
						--MF_alert(rule[1] .. ", " .. rule[2] .. ", " .. neweffect .. ": " .. b[1][1] .. ", " .. b[1][2] .. ", " .. b[1][3])
						local theseconds = b[2]
						
						if (#newconds > 0) then
							if (newconds[1] ~= "never") then
								for c,d in ipairs(newconds) do
									table.insert(theseconds, d)
								end
							else
								theseconds = {"never"}
							end
						end
						
						b[2] = theseconds
					end
				end
			end
		end
	end
	
	if (#protects > 0) then
		for i,v in ipairs(protects) do
			local rule = features[v]
			
			local baserule = rule[1]
			local conds = rule[2]
			
			local target = baserule[1]
			
			local newconds = {{"never"}}
			
			if (conds[1] ~= "never") then
				if (#conds > 0) then
					newconds = {}
					
					for a,b in ipairs(conds) do
						local condword = b[1]
						local condgroup = {}
						
						local newcondword = "not " .. condword
						
						if (string.sub(condword, 1, 3) == "not") then
							newcondword = string.sub(condword, 5)
						end
						
						if (b[2] ~= nil) then
							for c,d in ipairs(b[2]) do
								table.insert(condgroup, d)
							end
						end
						
						table.insert(newconds, {newcondword, condgroup})
					end
				end		
			
				if (featureindex[target] ~= nil) then
					for a,rules in ipairs(featureindex[target]) do
						local targetrule = rules[1]
						local targetconds = rules[2]
						
						local object = targetrule[3]
						
						if (targetrule[1] == target) and (targetrule[2] == "is") and (target ~= object) and (getmat(object) ~= nil) and (object ~= "group") then
							if (#newconds > 0) then
								if (newconds[1] == "never") then
									targetconds = {}
								end
								
								for c,d in ipairs(newconds) do
									table.insert(targetconds, d)
								end
							end
							
							rules[2] = targetconds
						end
					end
				end
			end
		end
	end
	
	ruleids = newruleids
	
	local rulename = "rule" .. tostring(math.random(1,5))
	
	if playrulesound then
		MF_playsound(rulename)
	end
	
	ruleblockeffect()
end

function iscond(word)
	local found = false
	
	for i,v in pairs(conditions) do
		if (word == i) or (word == "not " .. i) then
			found = true
			local args = v.arguments
			return true,args
		end
	end
	
	return false,0
end

function grouprules()
	local isgroup = {}
	local groupis = {}
	local groups = findgroup()
	
	if (featureindex["group"] ~= nil) then
		for i,rule in ipairs(featureindex["group"]) do
			local baserule = rule[1]
			local conds = rule[2]
			
			if (baserule[1] == "group") then
				table.insert(groupis, rule)
			end

			if (baserule[3] == "group") and (baserule[1] ~= "group") then
				table.insert(isgroup, rule)
			end
		end
	end
	
	local ends = {}
	local starts = {}
	
	if (#groupis > 0) then
		for i,rule in ipairs(groupis) do
			local baserule = rule[1]
			local conds = rule[2]
			local verb = baserule[2]
			local effect = baserule[3]
			
			table.insert(ends, {effect,verb,conds})
		end
	end			
	
	if (#isgroup > 0) then
		for i,rule in ipairs(isgroup) do
			local baserule = rule[1]
			local conds = rule[2]
			local verb = baserule[2]
			local target = baserule[1]
			
			table.insert(starts, {target,verb,conds})
		end
	end
	
	local ids = {}
	
	for i,v in ipairs(starts) do
		if (v[2] ~= "is") then
			local conds = {}
			if (#v[3] > 0) then
				for a,b in ipairs(v[3]) do
					table.insert(conds, b)
				end
			end
			
			for a,b in ipairs(starts) do
				if (b[2] == "is") then
					if (#b[3] > 0) then
						for c,d in ipairs(b[3]) do
							table.insert(conds, d)
						end
					end
					
					addoption({v[1],v[2],b[1]},conds,ids,false)
				end
			end
		end
		
		for a,b in ipairs(ends) do
			local conds = {}
			
			if (#v[3] > 0) then
				for c,d in ipairs(v[3]) do
					table.insert(conds, d)
				end
			end
			
			if (#b[3] > 0) then
				for c,d in ipairs(b[3]) do
					table.insert(conds, d)
				end
			end
			
			if (v[2] == "is") then
				addoption({v[1],b[2],b[1]},conds,ids,false)
			end
		end
	end
	
	if (#features > 0) and (#groups > 0) then
		for i,rules in ipairs(features) do
			local rule = rules[1]
			local conds = rules[2]
			
			if (#conds > 0) then
				for m,n in ipairs(conds) do
					if (n[2] ~= nil) then
						if (#n[2] > 0) then
							local thisrule = n[2]
							local limit = #n[2]
							local delthese = {}

							for a=1,limit do
								local b = thisrule[a]
								
								if (b == "group") then
									if (#groups > 0) then
										for c,d in ipairs(groups) do
											if (d[1] ~= "group") then
												table.insert(n[2], d[1])
												
												if (d[2] ~= nil) then
													for e,f in ipairs(d[2]) do
														if (f ~= "group") then
															table.insert(n[2], f)
														end
													end
												end
											end
										end
									end
									
									table.insert(delthese, a)
								end
							end
							
							if (#delthese > 0) then
								local offset = 0
								for a,b in ipairs(delthese) do
									local id = b + offset
									table.remove(n[2], id)
									offset = offset - 1
								end
							end
						end
					end
				end
			end
		end
	end					
end

function copyrule(rule)
	local baserule = rule[1]
	local conds = rule[2]
	local ids = rule[3]
	
	local newbaserule = {}
	local newconds = {}
	local newids = {}
	
	newbaserule = {baserule[1],baserule[2],baserule[3]}
	
	if (#conds > 0) then
		for i,cond in ipairs(conds) do
			local newcond = {cond[1]}
			
			if (cond[2] ~= nil) then
				local condnames = cond[2]
				newcond[2] = {}
				
				for a,b in ipairs(condnames) do
					table.insert(newcond[2], b)
				end
			end
			
			table.insert(newconds, newcond)
		end
	end
	
	if (#ids > 0) then
		for i,id in ipairs(ids) do
			table.insert(newids, id)
		end
	end
	
	local newrule = {newbaserule,newconds,newids}
	
	return newrule
end

function updatecombo(combo_,variants)
	local increment = 1
	local combo = {}
	
	for i,v in ipairs(variants) do
		combo[i] = combo_[i]
		if (v > 1) then
			combo[i] = combo[i] + increment
			increment = 0
			
			if (combo[i] > v) then
				combo[i] = 1
				increment = 1
			end
		elseif (v == 0) then
			--print("no variants here?")
		end
	end
	
	if (increment == 0) then
		return combo
	else
		return nil
	end
end

function comparerules(baserule1,baserule2)
	local same = true
	
	for i,v in ipairs(baserule1) do
		if (v ~= baserule2[i]) then
			same = false
		end
	end
	
	return same
end

function findwordunits()
	local result = {}
	local alreadydone = {}
	
	local identifier = ""
	
	if (unitlists["text_word"] ~= nil) then
		if (featureindex["word"] ~= nil) then
			for i,v in ipairs(featureindex["word"]) do
				local rule = v[1]
				local conds = v[2]
				
				local name = rule[1]
				
				if (objectlist[name] ~= nil) and (name ~= "text") and (alreadydone[name] == nil) then
					local these = findall({name,conds})
					alreadydone[name] = 1
					
					if (#these > 0) then
						for a,b in ipairs(these) do
							table.insert(result, b)
							identifier = identifier .. name
							-- LISÄÄ TÄHÄN LISÄÄ DATAA
						end
					end
				end
			end
		end
	end
	
	return result,identifier
end

function findword(text)
	local name = ""
	local type = -1
	
	if (unitreference[text] ~= nil) then
		local realname = unitreference[text]
		
		local tiledata = tileslist[realname]
		
		if (tiledata ~= nil) then
			name = tiledata.name
			type = tiledata.type or 0
		end
		
		if (changes[realname] ~= nil) then
			local c = changes[realname]
			
			if (c.name ~= nil) then
				name = c.name
			end
			
			if (c.type ~= nil) then
				name = c.type
			end
		end
	
		if (string.sub(name, 1, 5) == "text_") then
			name = string.sub(name, 6)
		end
	end
	
	return name,type
end

function ruleblockeffect()
	local handled = {}
	
	for i,rules in pairs(features) do
		local rule = rules[1]
		local conds = rules[2]
		local ids = rules[3]
		local blocked = false
		
		for a,b in ipairs(conds) do
			if (b[1] == "never") then
				blocked = true
				break
			end
		end
		
		if blocked then
			for a,b in ipairs(ids) do
				if (handled[b] == nil) then
					local blockid = MF_create("Ingame_blocked")
					local bunit = mmf.newObject(blockid)
					
					local runit = mmf.newObject(b)
					
					bunit.x = runit.x
					bunit.y = runit.y
					
					bunit.values[XPOS] = runit.values[XPOS]
					bunit.values[YPOS] = runit.values[YPOS]
					bunit.layer = 2
					bunit.values[ZLAYER] = 20
					bunit.values[TYPE] = b
					
					local c1,c2 = getuicolour("blocked")
					MF_setcolour(blockid,c1,c2)
					
					handled[b] = 2
				end
			end
		else
			for a,b in ipairs(ids) do
				if (handled[b] == nil) then
					handled[b] = 1
				elseif (handled[b] == 2) then
					MF_removeblockeffect(b)
				end
			end
		end
	end
end